### Intestelligence: A pharmacological neural network using intestine data
This repository includes the data and source code of [our paper](https://doi.org/10.1101/2023.04.15.537044) (This link will be updated to a DOI URL after being published).

#### Installation
``` bash
$ git clone git@gin.g-node.org:/intestelligence/intestelligence.git && cd intestelligence
$ python -m venv env && source env/bin/activate && pip install -r requirements.txt
```

#### Scripts
- [`./scripts/PerceptronOrINN.py`](./scripts/PerceptronOrINN.py):  
  Contains the definitions of Intestine-derived Neural Network (INN) and perceptron models.
- [`./scripts/train_MNIST.py`](./scripts/train_MNIST.py):  
  Trains and evaluates the INN or Perceptron model on the MNIST dataset.


#### Runs an example code
``` bash
$ python ./scripts/train_MNIST.py --activation_function intestine_simulated # INN
$ python ./scripts/train_MNIST.py --activation_function sigmoid # Perceptron
```


#### BibTeX Citation
``` bibtex
@article {Watanabe2023.04.15.537044,
	author = {Yusuke Watanabe and Hiroshi Ban and Nobuhiro Hagura and Yuji Ikegaya},
	title = {Intestelligence: A pharmacological neural network using intestine data},
	elocation-id = {2023.04.15.537044},
	year = {2023},
	doi = {10.1101/2023.04.15.537044},
	publisher = {Cold Spring Harbor Laboratory},
	abstract = {A neural network is a machine learning algorithm that can learn and make predictions by adjusting the strength of the connections between nodes. The sigmoid function is commonly used as an activation function in these nodes. This study explores the potential applicability of biological materials in the development of alternative activation functions. Inspired by the fact that acetylcholine induces intestinal contractions that follow a sigmoid function, we used pharmacological data obtained from guinea pig ilea in a layered neural network for image classification tasks. We found that the intestinal data-based neural network with the same structure as a conventional three-layer perceptron achieved an impressive classification accuracy of 85.7\% {\textpm} 0.6\% based on the MNIST handwritten digit dataset (chance = 10\%). Additionally, the neural network was trained to determine whether objects in photographs collected from the internet were digestible, achieving an accuracy of 88.5\% {\textpm} 0.9\% (chance = 50\%). Our approach highlights the potential applicability of intestine data in neural computations based on pharmacological mechanisms.Competing Interest StatementThe authors have declared no competing interest.},
	URL = {https://www.biorxiv.org/content/early/2023/04/17/2023.04.15.537044},
	eprint = {https://www.biorxiv.org/content/early/2023/04/17/2023.04.15.537044.full.pdf},
	journal = {bioRxiv}
}
```

